
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【ThinkingInJava】42、装饰器设计模式 / 憋错料</title>

    <meta name="description" content="【ThinkingInJava】42、装饰器设计模式 /** * 书本:&lt;Thinking In Java&gt; * 功能:装饰器设计模式 * 装饰器模式使用分层对象来动态透明的向单个对象添加责任.装饰器指定包装在最初的对象周围的所有对象都具有相同的基本接口 * 某些事物是可装饰的,可以通过将其他类包装在这个可装饰对象的四周,来将功能分层. * 装饰器是通过使用组合和形式化结构(可装饰物/装饰器层次结构)来实现的,而混型是基于继承的 * 文件:Decoration.java * 时间:2015年4月21日10:18:43 * 作者:cutt ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【ThinkingInJava】42、装饰器设计模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>/**
* 书本:《Thinking In Java》
* 功能:装饰器设计模式
* 		装饰器模式使用分层对象来动态透明的向单个对象添加责任。装饰器指定包装在最初的对象周围的所有对象都具有相同的基本接口
* 		某些事物是可装饰的，可以通过将其他类包装在这个可装饰对象的四周，来将功能分层。
* 		装饰器是通过使用组合和形式化结构（可装饰物/装饰器层次结构)来实现的，而混型是基于继承的
* 文件:Decoration.java
* 时间:2015年4月21日10:18:43
* 作者:cutter_point
*/
package Lesson15_generices.decorator;

import java.util.Date;

class Basic
{
	private String value;
	public void set(String val) { value = val; }
	public String get() { return value; }
}

class Decorator extends Basic	//这个里面有类的组合,同时还继承了这个类
{
	protected Basic basic;
	public Decorator(Basic basic) { this.basic = basic; }
	public void set(String val) { this.basic.set(val); }	//传的参数是Basic，但是里面用的value还是从Basic继承来的
	public String get() { return this.basic.get(); }
}

class TimeStamped extends Decorator
{
	private final long timeStamp;

	public TimeStamped(Basic basic)
	{
		super(basic);
		timeStamp = new Date().getTime();

	}
	public long getStamp() { return timeStamp; }
}

class SerialNumbered extends Decorator
{
	private static long counter = 1;
	private final long serialNumber = counter++;	//每当创建一个对象的时候，就对其进行一次计数
	public SerialNumbered(Basic basic) { super(basic); }
	public long getSerialNumber() { return serialNumber; }
}

public class Decoration
{

	public static void main(String[] args)
	{
		TimeStamped t = new TimeStamped(new Basic());
		TimeStamped t2 = new TimeStamped(new SerialNumbered(new Basic()));
//		t2.getSerialNumber();		//是错的，无法调用这个函数,就算后面创建的是SerialNumbered这个参数
		System.out.println(t.getStamp()+&quot;  &quot;+t2.getStamp());
		SerialNumbered s = new SerialNumbered(new Basic());
		SerialNumbered s2 = new SerialNumbered(new TimeStamped(new Basic()));
		System.out.println(s.getSerialNumber()+&quot;  &quot;+s2.getSerialNumber());
//		s2.getStamp();		//无法调用
	}

}
</pre>
<p>输出：</p>
<p>1431994101438&nbsp; 1431994101438</p>
<p>2&nbsp; 3</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 21:03:55 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java%e7%bc%96%e7%a8%8b%e6%80%9d%e6%83%b3/" title="java编程思想">java编程思想</a>, <a href="https://www.biecuoliao.com/tag/%e8%ae%be%e8%ae%a1%e6%a8%a1%e5%bc%8f/" title="设计模式">设计模式</a>, <a href="https://www.biecuoliao.com/tag/%e8%a3%85%e9%a5%b0%e5%99%a8/" title="装饰器">装饰器</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【ThinkingInJava】42、装饰器设计模式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qOnAGM.html" rel="bookmark">装饰器设计模式初探（Java实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇随笔主要介绍用Java实现简单的装饰器设计模式: 先来看一下装饰器设计模式的类图:  从图中可以看到,我们可以装饰Component接口的任何实现类,而这些实现类也包括了装饰器本身,装饰器本身也可以再被装饰. 下面是用Java实现的简单的装饰器设计模式,提供的是从基本的加入咖啡入手,可以继续加入牛奶,巧克力,糖的装饰器系统. 1 interface Component { 2 void method(); 3 } 4 class Coffee implements Component { 5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KA2WK4.html" rel="bookmark">装饰器设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通俗的讲装饰器就是在不改变对象结构的前提下,扩充对象的功能. 下面以effective java中例题 问题  我想扩充Hash&lt;set&gt;功能,使得能够统计添加过元素的个数? 或许你可能会自定义一个类通过继承扩展,从而实现计数功能,代码如下: package com.effectJava.Chapter2; import java.util.Arrays; import java.util.Collection; import java.util.HashSet; public class I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dvrj64.html" rel="bookmark">设计模式之---装饰器设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				职责:动态的为一个对象增加新的功能 装饰器模式是一种用于代替继承的技术,无需通过继承增加子类就能扩展对象的新功能.使用对象的关联关系代替继承关系,更加灵活,同时避免类型体系的快速膨胀. 实现细节: ——Component抽象构件角色:真实对象和装饰对象有相同的接口.这样,客户端对象就能够以与真实对象相同的方式同装饰对象交互. ——ConcreteComponent具体构件角色(真实对象):io流中的FileInputStream. FileOutputStream ——Decorator装饰角色			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YZRYN3.html" rel="bookmark">java 实现装饰器设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.gylhaut.base; /** * 装饰器 * 类与类之间的关系 * 1.依赖:形参(局部变量) * 2.关联:属性 * 聚合 属性 整体和部分 不一致的生命周期 人和手 * 组合 属性 整体和部分 一致的生命周期 人和大脑 * 3.继承:父子类关系 * 4.实现:接口与实现的关系 */ public class Decorator { private Voice voice; public void say(){ System.out.println(&quot;val=&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3w1AqZM.html" rel="bookmark">python学习-42 装饰器 --- 函数闭包1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数闭包举例: def father(name): print('hello world') def son(): print('儿子说:我的爸爸是%s' % name) def grandfson(): print('孙子说:我的爷爷是%s' % name) grandfson() son() father('小明') 运行结果: hello world 儿子说:我的爸爸是小明 孙子说:我的爷爷是小明 Process finished with exit code 0 函数的包: 就是嵌套里的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lXJyE0.html" rel="bookmark">IOS设计模式之二（门面模式，装饰器模式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文原文请见:http://www.raywenderlich.com/46988/ios-design-patterns. 由 @krq_tiger(http://weibo.com/xmuzyq)翻译,如果你发现有什么错误,请与我联系谢谢. 门面(Facade)模式(译者注:facade有些书籍译为门面,有些书籍译为外观,此处译为门面) 门面模式针对复杂的子系统提供了单一的接口,不需要暴漏一些列的类和API给用户,你仅仅暴漏一个简单统一的API. 下面的图解释了这个概念: 这个API的使用者			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NqrPG3.html" rel="bookmark">设计模式之&colon; 装饰器模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是装饰器模式 作为一种结构型模式, 装饰器(Decorator)模式就是对一个已有结构增加&quot;装饰&quot;. 适配器模式, 是为现在有结构增加的是一个适配器类,.将一个类的接口,转换成客户期望的另外一个接口.适配器让原本接口不兼容的类可以很好的合作. 装饰器模式是将一个对象包装起来以增强新的行为和责任.装饰器也称为包装器(类似于适配器) 有些设计设计模式包含一个抽象类,而且该抽象类还继承了另一个抽象类,这种设计模式为数不多,而装饰器就是其中之一. 什么时候使用装饰器模式 基本说来, 如果想			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6pv1d3.html" rel="bookmark">设计模式（八）装饰器模式Decorator（结构型）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式(八)装饰器模式Decorator(结构型) 1. 概述 若你从事过面向对象开发,实现给一个类或对象增加行为,使用继承机制,这是所有面向对象语言的一个基本特性.如果已经存在的一个类缺少某些方法,或者须要给方法添加更多的功能(魅力),你也许会仅仅继承这个类来产生一个新类—这建立在额外的代码上. 通过继承一个现有类可以使得子类在拥有自身方法的同时还拥有父类的方法.但是这种方法是静态的,用户不能控制增加行为的方式和时机.如果  你希望改变一个已经初始化的对象的行为,你怎么办?或者,你希望继承许			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPDe9yM.html" rel="bookmark">&lbrack;译&rsqb;Python之装饰器知必会</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				装饰器基础 Python的函数是对象 为了理解装饰器, 你必须先理解: 在Python的世界, 函数是对象. 这一点很重要. 让我们通过一个简单的例子来看看为什么: def shout(word=&quot;yes&quot;): return word.capitalize()+&quot;!&quot; print shout() # 输出 : 'Yes!' # 作为一个对象, 你可以像任何其他对象一样, 将函数赋值给一个变量 scream = shout # 注意, 我们并没有使用括号: # 我们没			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QM6EN54.html" rel="bookmark" class="title">调用函数时传递的实参个数arguments&period;length&semi;   &comma;函数定义时的形参个数sum&period;length</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5Z5w0.html" rel="bookmark" class="title">IE对象最后一个属性后不要加逗号，否则在IE7及以下版本中会报错</a>
					<div>
						某函数返回一个对象,如果在最后一个属性后加逗号,IE7及以下版本中会报错 正确代码: return{ top:rect.top-top, bottom:rect.bottom-top, left:re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Ygvda4.html" rel="bookmark" class="title">涛舅舅独家：JS-SDK分享接口的配置说明</a>
					<div>
						想要恢复使用微信分享的功能,最最根本和保险的方式还是早点学会用微信官方的js-sdk这个东西.... 下面具体讲一下应该怎么个操作法. 1.首先你得有一个微信公众号,并且是交了300块钱认证过了的.订 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qogEDM.html" rel="bookmark" class="title">匠以利器为助---移动设计师应该知道的8款利器</a>
					<div>
						导读: 不说废话,以下的8款软件首先都是眼下很优秀的移动开发工具,我觉得无论是移动开发.交互设计.UI都应该知道.事实上是应该会用,善用. 1.Sketch矢量画图软件   $79.99 是一款专业矢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7PqZ3.html" rel="bookmark" class="title">&lbrack;MachineLearning&rsqb;KNN</a>
					<div>
						# -*- coding: utf-8 -*- &quot;&quot;&quot; Created on Wed Jun 18 11:46:15 2014 @author: hp &quot;&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKQZa3.html" rel="bookmark" class="title">&lbrack;React Fundamentals&rsqb; Owner Ownee Relationship</a>
					<div>
						The owner-ownee relationship is used to designate a parent-child relationship with React components  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rknel4.html" rel="bookmark" class="title">Vijos Victoria的舞会3</a>
					<div>
						描述 Victoria是一位颇有成就的艺术家,他因油画作品&lt;我爱北京天安门&gt;闻名于世界.现在,他为了报答帮助他的同行们,准备开一个舞会. Victoria准备邀请n个已经确定的人,可是问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aOLev4.html" rel="bookmark" class="title">JAVA- String类练习</a>
					<div>
						JAVA- String类练习 需求1:去除字符串两边空格的函数,写一个自己的trim(); 1 public class TestTrim { 2 public static void main(S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORxaG0.html" rel="bookmark" class="title">做项目时需要考虑的安全性问题</a>
					<div>
						在开发一个项目的时候,大家经常会忽略项目的安全性问题,有很多的安全性问题其实就是一个意识的问题,解决起来并不复杂,但是因为这些疏忽,却可能会给我们的用户带来很大的风险.下面就列举一些在做项目的时候应该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWQEv4.html" rel="bookmark" class="title">MI04  盘点单数据录入</a>
					<div>
						*&amp;---------------------------------------------------------------------* *&amp; Report ZRHSSD002 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1wYl4.html" rel="bookmark" class="title">socket选项总结（setsocketopt）</a>
					<div>
						功能描述:        获取或者设置与某个套接字关联的选 项.选项可能存在于多层协议中,它们总会出现在最上面的套接字层.当操作套接字选项时,选项位于的层和选项的名称必须给出.为了操作套接字层的选项, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZkmB4.html" rel="bookmark" class="title">使用 document&period;onreadystatechange&lpar;&rpar;来判断页面加载完</a>
					<div>
						document.onreadystatechange = subSomething;//当页面加载状态改变的时候执行这个方法. function subSomething() {  if(docum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38bwblM.html" rel="bookmark" class="title">3673&colon; 可持久化并查集 by zky</a>
					<div>
						Time Limit: 5 Sec  Memory Limit: 128 MBSubmit: 2724  Solved: 1206[Submit][Status][Discuss] Descripti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZNXl83.html" rel="bookmark" class="title">Juniper老司机经验谈（SRX防火墙NAT与策略篇）视频课程上线了</a>
					<div>
						继前面的&lt;Juniper老司机经验谈(SRX防火墙优化篇)&gt;之后,Juniper老司机经验谈(SRX防火墙NAT与策略篇)第二部视频课程也录制上线了 1.两个课程完全独立又相结合, SRX ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZNLmJ3.html" rel="bookmark" class="title">第一次搭建lamp架构笔记</a>
					<div>
						感谢MK老师提供技术指导以及资料.视频 特别鸣谢步行街同学一路陪伴,耐心指导 拷贝源码包 [[email protected] ~]# [email protected]:/Users/duwen/D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41DGJv3.html" rel="bookmark" class="title">【好程序员笔记分享】C语言之while语句</a>
					<div>
						ios培训------我的c语言笔记,期待与您交流! #include &lt;stdio.h&gt; /* while (条件) { 循环体 } 运行原理 1.如果一开始条件就不成立,永远不会执行循 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9BXX4.html" rel="bookmark" class="title">XCode  自动化打包总结</a>
					<div>
						最近一个礼拜折腾xcode 中ipa 自动化打包,对我来说也说是磕磕碰碰.毕竟对mac下的命令行模式完全不熟悉.而且我们的项目是基于cordova的一个项目. 之前我自己对cordova 项目的命令行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDEE60.html" rel="bookmark" class="title">修正PHP时区的三个办法</a>
					<div>
						在PHP5.2.4之前的版本无需配置时区.下面是修正PHP时区的三个办法,仅供参考,具体可以学习PHP高级实用技巧教程. 1.修正PHP.ini这个文件 找到date.timezone这行,去掉先面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bLprk4.html" rel="bookmark" class="title">Android 自定义View 实例</a>
					<div>
						Android 相关自定义View基本知识可以参考 Android View 自定义属性, 本篇博客博主将和大家一起实践Android自定义View,我们知道,在应用中最常见的就是TitleBar,他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Za21m0.html" rel="bookmark" class="title">keepalied和haproxy的部署及配置</a>
					<div>
						Keepalived部署 编译keepalived #cd /opt/soft # wget http://www.keepalived.org/software/keepalived-1.2.12. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
